Index: /BAORadio/libindi/libindi/libs/indibase/defaultdriver.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/defaultdriver.cpp	(revision 503)
+++ /BAORadio/libindi/libindi/libs/indibase/defaultdriver.cpp	(revision 504)
@@ -8,4 +8,18 @@
 #include "base64.h"
 
+void timerfunc(void *t)
+{
+    //fprintf(stderr,"Got a timer hit with %x\n",t);
+    INDI::DefaultDriver *devPtr = static_cast<INDI::DefaultDriver *> (t);
+    if (devPtr != NULL)
+    {
+        //  this was for my device
+        //  but we dont have a way of telling
+        //  WHICH timer was hit :(
+        devPtr->TimerHit();
+    }
+    return;
+}
+
 
 INDI::DefaultDriver::DefaultDriver()
@@ -13,4 +27,14 @@
     pDebug = false;
     pSimulation = false;
+
+    //switchPtr conSw(new ISwitchVectorProperty);
+    ConnectionSP = new ISwitchVectorProperty;
+
+    IUFillSwitch(&ConnectionS[0],"CONNECT","Connect",ISS_OFF);
+    IUFillSwitch(&ConnectionS[1],"DISCONNECT","Disconnect",ISS_ON);
+    IUFillSwitchVector(ConnectionSP,ConnectionS,2,deviceName(),"CONNECTION","Connection","Main Control",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+
+    registerProperty(ConnectionSP, INDI_SWITCH);
+
 }
 
@@ -32,6 +56,12 @@
 bool INDI::DefaultDriver::saveConfig()
 {
-    std::vector<pOrder>::const_iterator orderi;
+    //std::vector<orderPtr>::iterator orderi;
+
+    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
+
     ISwitchVectorProperty *svp=NULL;
+    INumberVectorProperty *nvp=NULL;
+    ITextVectorProperty   *tvp=NULL;
+    IBLOBVectorProperty   *bvp=NULL;
     char errmsg[MAXRBUF];
     FILE *fp = NULL;
@@ -49,14 +79,18 @@
     for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
     {
-        switch ( (*orderi).type)
+
+        switch (orderi->second)
         {
         case INDI_NUMBER:
-             IUSaveConfigNumber(fp, static_cast<INumberVectorProperty *> ((*orderi).p));
+             nvp = static_cast<INumberVectorProperty *>((orderi->first).get());
+             IDLog("Trying to save config for number %s\n", nvp->name);
+             IUSaveConfigNumber(fp, nvp);
              break;
         case INDI_TEXT:
-             IUSaveConfigText(fp, static_cast<ITextVectorProperty *> ((*orderi).p));
+             tvp = static_cast<ITextVectorProperty *>((orderi->first).get());
+             IUSaveConfigText(fp, tvp);
              break;
         case INDI_SWITCH:
-             svp = static_cast<ISwitchVectorProperty *> ((*orderi).p);
+             svp = static_cast<ISwitchVectorProperty *>((orderi->first).get());
              /* Never save CONNECTION property. Don't save switches with no switches on if the rule is one of many */
              if (!strcmp(svp->name, "CONNECTION") || (svp->r == ISR_1OFMANY && !IUFindOnSwitch(svp)))
@@ -65,5 +99,6 @@
              break;
         case INDI_BLOB:
-             IUSaveConfigBLOB(fp, static_cast<IBLOBVectorProperty *> ((*orderi).p));
+             bvp = static_cast<IBLOBVectorProperty *>((orderi->first).get());
+             IUSaveConfigBLOB(fp, bvp);
              break;
         }
@@ -116,4 +151,50 @@
     if (!svp)
         return false;
+
+     if(!strcmp(svp->name,ConnectionSP->name))
+     {
+        bool rc;
+        
+      for (int i=0; i < n; i++)
+      {
+        if ( !strcmp(names[i], "CONNECT") && (states[i] == ISS_ON))
+        {
+            // If not connected, attempt to connect
+            if (isConnected() == false)
+            {
+                rc = Connect();
+
+                // If connection is successful, set it thus
+                if (rc)
+                  setConnected(true);
+                else
+                  setConnected(false, IPS_ALERT);
+
+                updateProperties();
+            }
+            else
+                // Just tell client we're connected yes
+                setConnected(true);
+        }
+        else if ( !strcmp(names[i], "DISCONNECT") && (states[i] == ISS_ON))
+        {
+            // If connected, then true to disconnect.
+            if (isConnected() == true)
+                rc = Disconnect();
+            else
+                rc = true;
+
+            if (rc)
+                setConnected(false, IPS_IDLE);
+            else
+                setConnected(true, IPS_ALERT);
+
+            updateProperties();
+        }
+    }
+
+        return true;
+    }
+
 
     if (!strcmp(svp->name, "DEBUG"))
@@ -174,5 +255,5 @@
 }
 
-void INDI::DefaultDriver::addAuxControls()
+void INDI::DefaultDriver::addDebugControl()
 {
     /**************************************************************************/
@@ -180,11 +261,10 @@
     if (!DebugSP)
     {
-        DebugSP = new ISwitchVectorProperty;
+        switchPtr debSw(new ISwitchVectorProperty);
+        DebugSP = debSw.get();
         IUFillSwitch(&DebugS[0], "ENABLE", "Enable", ISS_OFF);
         IUFillSwitch(&DebugS[1], "DISABLE", "Disable", ISS_ON);
         IUFillSwitchVector(DebugSP, DebugS, NARRAY(DebugS), deviceID, "DEBUG", "Debug", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
-        pSwitches.push_back(DebugSP);
-        pOrder debo = {INDI_SWITCH, DebugSP};
-        pAll.push_back(debo);
+        pAll[debSw] = INDI_SWITCH;
     }
     else
@@ -197,15 +277,18 @@
     /**************************************************************************/
 
+}
+
+void INDI::DefaultDriver::addSimulationControl()
+{
     /**************************************************************************/
     SimulationSP = getSwitch("SIMULATION");
     if (!SimulationSP)
     {
-        SimulationSP = new ISwitchVectorProperty;
+        switchPtr simSw(new ISwitchVectorProperty);
+        SimulationSP = simSw.get();
         IUFillSwitch(&SimulationS[0], "ENABLE", "Enable", ISS_OFF);
         IUFillSwitch(&SimulationS[1], "DISABLE", "Disable", ISS_ON);
         IUFillSwitchVector(SimulationSP, SimulationS, NARRAY(SimulationS), deviceID, "SIMULATION", "Simulation", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
-        pSwitches.push_back(SimulationSP);
-        pOrder simo = {INDI_SWITCH, SimulationSP};
-        pAll.push_back(simo);
+        pAll[simSw] = INDI_SWITCH;
     }
     else
@@ -216,17 +299,19 @@
                 pSimulation = true;
     }
-
+}
+
+void INDI::DefaultDriver::addConfigurationControl()
+{
     /**************************************************************************/
     ConfigProcessSP = getSwitch("CONFIG_PROCESS");
     if (!ConfigProcessSP)
     {
-        ConfigProcessSP = new ISwitchVectorProperty;
+        switchPtr configSw(new ISwitchVectorProperty);
+        ConfigProcessSP = configSw.get();
         IUFillSwitch(&ConfigProcessS[0], "CONFIG_LOAD", "Load", ISS_OFF);
         IUFillSwitch(&ConfigProcessS[1], "CONFIG_SAVE", "Save", ISS_OFF);
         IUFillSwitch(&ConfigProcessS[2], "CONFIG_DEFAULT", "Default", ISS_OFF);
         IUFillSwitchVector(ConfigProcessSP, ConfigProcessS, NARRAY(ConfigProcessS), deviceID, "CONFIG_PROCESS", "Configuration", "Options", IP_RW, ISR_1OFMANY, 0, IPS_IDLE);
-        pSwitches.push_back(ConfigProcessSP);
-        pOrder cpono = {INDI_SWITCH, ConfigProcessSP};
-        pAll.push_back(cpono);
+        pAll[configSw] = INDI_SWITCH;
     }
     /**************************************************************************/
@@ -234,6 +319,16 @@
 }
 
+void INDI::DefaultDriver::addAuxControls()
+{
+   addDebugControl();
+   addSimulationControl();
+   addConfigurationControl();
+}
+
 void INDI::DefaultDriver::setDebug(bool enable)
 {
+    if (!DebugSP)
+        return;
+
     if (pDebug == enable)
     {
@@ -242,7 +337,4 @@
         return;
     }
-
-    if (!DebugSP)
-        return;
 
     IUResetSwitch(DebugSP);
@@ -275,4 +367,7 @@
 void INDI::DefaultDriver::setSimulation(bool enable)
 {
+    if (!SimulationSP)
+        return;
+
    if (pSimulation == enable)
    {
@@ -281,7 +376,4 @@
        return;
    }
-
-   if (!SimulationSP)
-       return;
 
    IUResetSwitch(SimulationSP);
@@ -324,42 +416,63 @@
 void INDI::DefaultDriver::ISGetProperties (const char *dev)
 {
-    std::vector<pOrder>::const_iterator orderi;
+    std::map< boost::shared_ptr<void>, INDI_TYPE>::iterator orderi;
+    static int isInit = 0;
+
+    //fprintf(stderr,"Enter ISGetProperties '%s'\n",dev);
+    if(isInit == 0)
+    {
+        if(dev != NULL)
+             setDeviceName(dev);
+        else
+        {
+            char *envDev = getenv("INDIDEV");
+            if (envDev != NULL)
+                setDeviceName(envDev);
+            else
+               setDeviceName(getDefaultName());
+        }
+
+        strncpy(ConnectionSP->device, deviceName(), MAXINDIDEVICE);
+        initProperties();
+        addConfigurationControl();
+
+        isInit = 1;
+    }
 
     for (orderi = pAll.begin(); orderi != pAll.end(); orderi++)
     {
-        switch ( (*orderi).type)
+        switch (orderi->second)
         {
         case INDI_NUMBER:
-             IDDefNumber(static_cast<INumberVectorProperty *>((*orderi).p) , NULL);
+             IDDefNumber(static_cast<INumberVectorProperty *>((orderi->first).get()) , NULL);
              break;
         case INDI_TEXT:
-             IDDefText(static_cast<ITextVectorProperty *>((*orderi).p) , NULL);
+             IDDefText(static_cast<ITextVectorProperty *>((orderi->first).get()) , NULL);
              break;
         case INDI_SWITCH:
-             IDDefSwitch(static_cast<ISwitchVectorProperty *>((*orderi).p) , NULL);
+             IDDefSwitch(static_cast<ISwitchVectorProperty *>((orderi->first).get()) , NULL);
              break;
         case INDI_LIGHT:
-             IDDefLight(static_cast<ILightVectorProperty *>((*orderi).p) , NULL);
+             IDDefLight(static_cast<ILightVectorProperty *>((orderi->first).get()) , NULL);
              break;
         case INDI_BLOB:
-             IDDefBLOB(static_cast<IBLOBVectorProperty *>((*orderi).p) , NULL);
+             IDDefBLOB(static_cast<IBLOBVectorProperty *>((orderi->first).get()) , NULL);
              break;
         }
     }
-
 }
 
 void INDI::DefaultDriver::resetProperties()
 {
-    std::vector<INumberVectorProperty *>::const_iterator numi;
-    std::vector<ISwitchVectorProperty *>::const_iterator switchi;
-    std::vector<ITextVectorProperty *>::const_iterator texti;
-    std::vector<ILightVectorProperty *>::const_iterator lighti;
-    std::vector<IBLOBVectorProperty *>::const_iterator blobi;
+    /*std::vector<numberPtr>::const_iterator numi;
+    std::vector<switchPtr>::const_iterator switchi;
+    std::vector<textPtr>::const_iterator texti;
+    std::vector<lightPtr>::const_iterator lighti;
+    std::vector<blobPtr>::const_iterator blobi;
 
     for ( numi = pNumbers.begin(); numi != pNumbers.end(); numi++)
     {
         (*numi)->s = IPS_IDLE;
-        IDSetNumber( (*numi), NULL);
+        IDSetNumber( (*numi).get(), NULL);
     }
 
@@ -367,5 +480,5 @@
    {
        (*switchi)->s = IPS_IDLE;
-       IDSetSwitch( (*switchi), NULL);
+       IDSetSwitch( (*switchi).get(), NULL);
    }
 
@@ -373,5 +486,5 @@
    {
       (*texti)->s = IPS_IDLE;
-      IDSetText( (*texti), NULL);
+      IDSetText( (*texti).get(), NULL);
    }
 
@@ -379,5 +492,5 @@
    {
        (*lighti)->s = IPS_IDLE;
-       IDSetLight( (*lighti), NULL);
+       IDSetLight( (*lighti).get(), NULL);
    }
 
@@ -385,5 +498,108 @@
    {
        (*blobi)->s = IPS_IDLE;
-       IDSetBLOB( (*blobi), NULL);
-   }
-}
+       IDSetBLOB( (*blobi).get(), NULL);
+   }*/
+}
+
+void INDI::DefaultDriver::setConnected(bool status, IPState state, const char *msg)
+{
+    ISwitch *sp = NULL;
+    ISwitchVectorProperty *svp = getSwitch("CONNECTION");
+    if (!svp)
+        return;
+
+    IUResetSwitch(svp);
+
+    // Connect
+    if (status)
+    {
+        sp = IUFindSwitch(svp, "CONNECT");
+        if (!sp)
+            return;
+        sp->s = ISS_ON;
+    }
+    // Disconnect
+    else
+    {
+        sp = IUFindSwitch(svp, "DISCONNECT");
+        if (!sp)
+            return;
+        sp->s = ISS_ON;
+    }
+
+    svp->s = state;
+
+    IDSetSwitch(svp, msg, NULL);
+}
+
+//  This is a helper function
+//  that just encapsulates the Indi way into our clean c++ way of doing things
+int INDI::DefaultDriver::SetTimer(int t)
+{
+    return IEAddTimer(t,timerfunc,this);
+}
+
+//  Just another helper to help encapsulate indi into a clean class
+void INDI::DefaultDriver::RemoveTimer(int t)
+{
+    IERmTimer(t);
+    return;
+}
+
+//  This is just a placeholder
+//  This function should be overriden by child classes if they use timers
+//  So we should never get here
+void INDI::DefaultDriver::TimerHit()
+{
+    return;
+}
+
+
+bool INDI::DefaultDriver::updateProperties()
+{
+    //  The base device has no properties to update
+    return true;
+}
+
+
+bool INDI::DefaultDriver::initProperties()
+{
+   return true;
+}
+
+bool INDI::DefaultDriver::deleteProperty(const char *propertyName)
+{
+    removeProperty(propertyName);
+    IDDelete(deviceName(), propertyName ,NULL);
+    return true;
+}
+
+void INDI::DefaultDriver::defineNumber(INumberVectorProperty *nvp)
+{
+    registerProperty(nvp, INDI_NUMBER);
+    IDDefNumber(nvp, NULL);
+}
+
+void INDI::DefaultDriver::defineText(ITextVectorProperty *tvp)
+{
+    registerProperty(tvp, INDI_TEXT);
+    IDDefText(tvp, NULL);
+}
+
+void INDI::DefaultDriver::defineSwitch(ISwitchVectorProperty *svp)
+{
+    registerProperty(svp, INDI_SWITCH);
+    IDDefSwitch(svp, NULL);
+}
+
+void INDI::DefaultDriver::defineLight(ILightVectorProperty *lvp)
+{
+    registerProperty(lvp, INDI_LIGHT);
+    IDDefLight(lvp, NULL);
+}
+
+void INDI::DefaultDriver::defineBLOB(IBLOBVectorProperty *bvp)
+{
+    registerProperty(bvp, INDI_BLOB);
+    IDDefBLOB(bvp, NULL);
+}
Index: /BAORadio/libindi/libindi/libs/indibase/defaultdriver.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/defaultdriver.h	(revision 503)
+++ /BAORadio/libindi/libindi/libs/indibase/defaultdriver.h	(revision 504)
@@ -26,7 +26,63 @@
     void addAuxControls();
 
+    /** \brief Add Debug control to the driver */
+    void addDebugControl();
+
+    /** \brief Add Simulation control to the driver */
+    void addSimulationControl();
+
+    /** \brief Add Configuration control to the driver */
+    void addConfigurationControl();
+
     /** \brief Set all properties to IDLE state */
     void resetProperties();
 
+    /** \brief Define number vector to client & register it. Alternatively, IDDefNumber can be used but the property will not
+               get registered and the driver will not be able to save configuration files.
+         \param nvp The number vector property to be defined
+    */
+    void defineNumber(INumberVectorProperty *nvp);
+
+    /** \brief Define text vector to client & register it. Alternatively, IDDefText can be used but the property will not
+               get registered and the driver will not be able to save configuration files.
+         \param tvp The text vector property to be defined
+    */
+    void defineText(ITextVectorProperty *tvp);
+
+    /** \brief Define switch vector to client & register it. Alternatively, IDDefswitch can be used but the property will not
+               get registered and the driver will not be able to save configuration files.
+         \param svp The switch vector property to be defined
+    */
+    void defineSwitch(ISwitchVectorProperty *svp);
+
+    /** \brief Define light vector to client & register it. Alternatively, IDDeflight can be used but the property will not
+               get registered and the driver will not be able to save configuration files.
+         \param lvp The light vector property to be defined
+    */
+    void defineLight(ILightVectorProperty *lvp);
+
+    /** \brief Define BLOB vector to client & register it. Alternatively, IDDefBLOB can be used but the property will not
+               get registered and the driver will not be able to save configuration files.
+         \param bvp The BLOB vector property to be defined
+    */
+    void defineBLOB(IBLOBVectorProperty *bvp);
+
+
+    /** \brief Delete a property and unregister it. It will also be deleted from all clients.
+        \param propertyName name of property to be deleted.
+    */
+    virtual bool deleteProperty(const char *propertyName);
+
+    /** \brief Connect or Disconnect a device.
+      \param status If true, the driver will attempt to connect to the device (CONNECT=ON). If false, it will attempt
+to disconnect the device.
+      \param msg A message to be sent along with connect/disconnect command.
+    */
+    virtual void setConnected(bool status, IPState state=IPS_OK, const char *msg = NULL);
+
+    int SetTimer(int);
+    void RemoveTimer(int);
+    virtual void TimerHit();
+
 protected:
 
@@ -95,4 +151,39 @@
     /** \return True if Simulation is on, False otherwise. */
     bool isSimulation();
+
+    //  These are the properties we define, that are generic to pretty much all devices
+    //  They are public to make them available to all dervied classes and thier children
+    ISwitchVectorProperty *ConnectionSP;
+    ISwitch ConnectionS[2];
+
+
+    /** \brief Initilize properties initial state and value. The child class must implement this function.
+        \return True if initilization is successful, false otherwise.
+    */
+    virtual bool initProperties();
+
+    /** \brief updateProperties is called whenever there is a change in the CONNECTION status of the driver.
+        This will enable the driver to react to changes of switching ON/OFF a device. For example, a driver
+        may only define a set of properties after a device is connected, but not before.
+        \return True if update is successful, false otherwise.
+    */
+    virtual bool updateProperties();
+
+    /** \brief Connect to a device. Child classes must implement this function and perform the connection
+        routine in the function.
+        \return True if connection to device is successful, false otherwise.
+    */
+    virtual bool Connect()=0;
+
+    /** \brief Disconnect from a device. Child classes must implement this function and perform the disconnection
+        routine in the function.
+        \return True if disconnection from a device is successful, false otherwise.
+    */
+    virtual bool Disconnect()=0;
+
+    /** \return Default name of the device. */
+    virtual const char *getDefaultName()=0;
+
+
 
 private:
